#include "problem.h"
#include <meshagent.h>
#include "stdloop.h"

using namespace Gascoigne;

//Problem 2.5
class LocalLoop : public StdLoop
{
public:
  void BasicInit(const ParamFile& paramfile,
                 const ProblemContainer* PC,
                 const FunctionalContainer* FC)
    {
      GetMeshAgentPointer() = new MyMeshAgent;
      StdLoop::BasicInit(paramfile, PC, FC);
    }
};


int main(int argc, char **argv)
{
  ParamFile paramfile("gascoigne.param");
  if(argc>=2) {
    paramfile.SetName(argv[1]);
  }


  MyProblemDescriptor MPD;
  MPD.BasicInit(paramfile);

  ProblemContainer PC;
  PC.AddProblem("Laplace Problem", &MPD);

  FunctionalContainer FC;

  StdLoop loop;
  loop.BasicInit(paramfile, &PC, &FC);
  loop.run("Laplace Problem");

  return 0;
}
